<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <title>Rasa Core Visualisation</title>
    <script src="https://dagrejs.github.io/project/dagre-d3/latest/dagre-d3.min.js"></script>
    <script src="https://dagrejs.github.io/project/dagre/latest/dagre.min.js"></script>
    <script src="https://d3js.org/d3.v4.js"></script>
    <script src="https://dagrejs.github.io/project/graphlib-dot/v0.6.3/graphlib-dot.js"></script>
</head>
<body>
<div id="errormsg" style="color: #b00"></div>
<svg>
    <style>
        .node.invisible > rect {
            display: none;
        }

        .node.start > rect {
            fill: #7f7;
            rx: 30;
            ry: 18;
        }

        .node.end > rect {
            fill: #f77;
            rx: 30;
            ry: 18;
        }

        .node:not(.active) > rect, .node:not(.active) > .label {
            opacity: 0.4;
        }

        .edgePath:not(.active) path {
            opacity: 0.4;
        }

        .node.ellipsis > rect {
            fill: #CCC;
        }

        .node.intent > rect {
            fill: #7ff;
        }

        .node.dashed > rect {
            stroke-dasharray: 5;
        }

        text {
            font-weight: 300;
            font-family: "Helvetica Neue", Helvetica, Arial, sans-serf, serif;
            font-size: 14px;
            color: #1f1d1d;
        }

        .node rect {
            stroke: #444;
            fill: #fff;
            stroke-width: 1.5px;
        }

        .edgePath path {
            stroke: #333;
            stroke-width: 1.5px;
        }

        svg {
            position: fixed;
            top: 10px;
            left: 0;
            height: 100%;
            width: 100%
        }
    </style>
    <g></g>
</svg>
<script>

  function serveGraph() {
    let oldInputGraphValue;

    const url = 'visualization.dot';
    const refreshInterval = 500;

    // trigger a refresh by fetching an updated graph
    setInterval(function () {
      fetch(url).then(r => r.text()).then(dot => {
        document.getElementById('errormsg').innerHTML = '';
        if (oldInputGraphValue === dot) return;

        oldInputGraphValue = dot;
        drawGraph(dot);
      }).catch(err => {
        document.getElementById('errormsg').innerHTML =
          'Failed to update plot. (' + err.message + ')';
      });
    }, refreshInterval);
  }

  function drawGraph(graph) {
    let g = graphlibDot.read(graph);
    // Set margins, if not present
    if (!g.graph().hasOwnProperty("marginx") &&
      !g.graph().hasOwnProperty("marginy")) {
      g.graph().marginx = 20;
      g.graph().marginy = 20;
    }
    g.graph().transition = function (selection) {
      return selection.transition().duration(300);
    };
    // Render the graph into svg g
    d3.select("svg g").call(render, g);
  }
  // Set up zoom support
  const svg = d3.select("svg"),
    inner = d3.select("svg g"),
    zoom = d3.zoom().on("zoom", function () {
      inner.attr("transform", d3.event.transform);
    });
  svg.call(zoom);

  // Create and configure the renderer
  const render = dagreD3.render();

  let isClient = false;
  isClient = true;

  if (isClient) {
    // Mark all nodes and their edges as active
    cssRules = document.styleSheets[0].cssRules;
    cssRules[3].style.opacity = 1;
    cssRules[4].style.opacity = 1;

    let graph;
    graph = `digraph  {
0 [class="start active", fillcolor=green, fontsize=12, label=START, style=filled];
"-1" [class=end, fillcolor=red, fontsize=12, label=END, style=filled];
1 [class="", fontsize=12, label=utter_greet];
2 [class="", fontsize=12, label=utter_did_that_help];
5 [class="", fontsize=12, label=utter_thankyou];
8 [class="", fontsize=12, label=utter_sorry];
9 [class="", fontsize=12, label=utter_goodbye];
10 [class="", fontsize=12, label=respond_faq];
11 [class="", fontsize=12, label=action_set_faq_slot];
12 [class="", fontsize=12, label=utter_iamabot];
15 [class="", fontsize=12, label=utter_cungcap_cmt];
16 [class="", fontsize=12, label=utter_cungcap_ho_ten];
17 [class="", fontsize=12, label="utter_cungcap_sđt"];
18 [class="", fontsize=12, label=utter_xacnhan_mo_tkck];
19 [class=intent, fillcolor=lightblue, label="Chào bạn", shape=rect, style=filled];
20 [class=intent, fillcolor=lightblue, label="tạm biệt", shape=rect, style=filled];
21 [class=intent, fillcolor=lightblue, label="Cho a biết cần làm gì khi giao dịch CKPS đi", shape=rect, style=filled];
22 [class=intent, fillcolor=lightblue, label="bạn là người hay bot", shape=rect, style=filled];
23 [class=intent, fillcolor=lightblue, label="Okay nha", shape=rect, style=filled];
24 [class=intent, fillcolor=lightblue, label="I don't think so", shape=rect, style=filled];
25 [class=intent, fillcolor=lightblue, label="Tôi muốn mở TKCK tại VPS", shape=rect, style=filled];
26 [class=intent, fillcolor=lightblue, label="CMT của tôi là 123456789", shape=rect, style=filled];
27 [class=intent, fillcolor=lightblue, label="Nguyễn Thị B", shape=rect, style=filled];
28 [class=intent, fillcolor=lightblue, label=012345678, shape=rect, style=filled];
0 -> 19  [class="", key=0];
0 -> 20  [class="", key=0];
0 -> 21  [class="", key=0];
0 -> 22  [class="", key=0];
1 -> 2  [class="", key=NONE, label=""];
2 -> "-1"  [class="", key=NONE, label=""];
2 -> 23  [class="", key=0];
2 -> 24  [class="", key=0];
2 -> 25  [class="", key=0];
5 -> "-1"  [class="", key=NONE, label=""];
8 -> "-1"  [class="", key=NONE, label=""];
9 -> "-1"  [class="", key=NONE, label=""];
10 -> 11  [class="", key=NONE, label=""];
11 -> "-1"  [class="", key=NONE, label=""];
12 -> "-1"  [class="", key=NONE, label=""];
15 -> 26  [class="", key=0];
16 -> 27  [class="", key=0];
17 -> 28  [class="", key=0];
18 -> "-1"  [class="", key=NONE, label=""];
19 -> 1  [class="", key=0];
20 -> 9  [class="", key=0];
21 -> 10  [class="", key=0];
22 -> 12  [class="", key=0];
23 -> 5  [class="", key=0];
24 -> 8  [class="", key=0];
25 -> 15  [class="", key=0];
26 -> 16  [class="", key=0];
27 -> 17  [class="", key=0];
28 -> 18  [class="", key=0];
}
`;
    drawGraph(graph);
  } else {
    serveGraph();
  }


</script>
</body>
</html>
